#include	<stdio.h>
#include	<sys_doslib.h>
#include	<string.h>

#include	"wlib.h"
#include	"parts.h"
#include	"winop.h"
#include	<HS_wlib.h>

/*	Modified by 1991,92,93 H.Ogasawara (COR.)	*/

#define	COM
#include	"com.h"

int	WindowHeapSize= 1024 *2;


typedef struct {
	short		flag;
	WindowID	wp;
	void		(*exec)();
} ConsoleType;

/*
 *		ϐ`
 */
unsigned char	CharBuf[LINES][COLUMS];
int		ExecFlag;
int		ScrH= COLUMS-1,
		ScrV= LINES;
int		Cx, Cy;
int		VirCx;
WindowID	TitleWP,
		ComWP,
		DummyWP;
int		ChildFlag;
int		Xdot= 8,
		Ydot= 16;
int		TabGap= 8;
int		BufferFlag= TRUE;
int		ScrollUnit= 4;
int		OFFSET= 4;
unsigned short	Attr= 9;

unsigned char	Prompt[256];
static unsigned char	Comline[256];
static InputClass	Input;

/* 1991 COR. */
short	cor_flag= HISTORYMODE;
short	insertmode= TRUE;
short	cshmode= FALSE;
short	bgmode= FALSE;
short	IconMode= FALSE;
extern unsigned char	keystr[][34];
extern short	directrun;
unsigned char	title_str[32]= { 'C','o','m','m','a','n','d',' ','0','0',0 };
				/* Command 00 */

/*
	proto -s command.c > temp
*/
static	int	TitleExec( WindowID, EventInfo* );
static	int	DummyExec( WindowID, EventInfo* );
static	void	GetKey( int, int );

void
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	int	i;
	int	x= 100,
		y= 100,
		h= 414,		/* 400 + 14 */
		v= 254;
	char	*rcname= "Command";

	argc= AnalyzeArgs( argc, argv, &x, &y, &h, &v );
	title_str[8]= WindowProcessID/10 +'0';
	title_str[9]= WindowProcessID%10 +'0';
	for( i = 1 ; i < argc ; i++ ){
		if( argv[i][0] == '/' || argv[i][0] == '-' ){
			switch( argv[i][1]|0x20 ){
				case 'o':
					OFFSET= atoi2( argv[i] + 2 );
					break;
				case 'f':
					Ydot= atoi2( argv[i] + 2 );
					Xdot= Ydot/2;
					break;
				case 'c': {
					short	n= atoi2( argv[i] + 2 );
					if( n >= COLUMS )
						n= COLUMS - 1;
					ScrH= n;
					}
					break;
				case 'd':
					directrun= TRUE;
					break;
				case 'n':
					rcname= argv[i]+2;
					break;
				case 't':
					strncpy( title_str, argv[i]+2, 31 );
					title_str[31]= '\0';
					break;
				case 'a':
					SetAttr( Attr= atoi2( argv[i] + 2 ) );
					break;
				case 'e':
					if( (argv[i][2]|0x20) == 'm' )
						cor_flag= EMACSMODE;
					else
						cor_flag= EDXMODE;
			}
		}
	}
	memset( keystr, 0, 20*34 );	/* funckey init */
	HistoryInit();
	WindowTitleOpen( x, y, h, v, NULL, title_str,
				Icon|Resize|Close|Push|Zoom, TitleExec );

	InputSetCursorVisible( NULL, &Input, FALSE );
	WindowRedraw( TitleWP );

	Print( "Command Line Emulator Version 1.13+13.1\n" );
	Print( "Copyright (C) T.Kobayashi 1990,1991. / H.Ogasawara 1991-96.\n\n" );
	if( !strcmp( title_str, "Console" ) ){
		if( !WindowGetCommon( "Console", 0 ) ){
			void		PrintChar();
			ConsoleType	*consptr;
			consptr= WindowGetCommon( "Console", 10 );
			consptr->flag= 0;
			consptr->wp= TitleWP;
			consptr->exec= PrintChar;
		}
	}

	GetPrompt( Prompt );
	{ /* ReadRC();*/
		unsigned char	buf[256];
		if( CommonOpen( rcname ) ){
			while( CommonGetLine( buf ) )
				ChildExec( buf );
		}
	}
	PrintLine( Prompt, FALSE );
	InputSet( &Input, OFFSET+Xdot*strlen( Prompt ),
				Cy*Ydot, Comline, ScrH, Attr, Ydot );
	InputSetCursorVisible( NULL, &Input, FALSE );
}

static int
TitleExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	buf[5];
	static	ZoomBuffer	zoom;

	switch( info->option ){
		case EventOpen:
			TitleWP= wp;
			ZoomInit( wp, &zoom );
			WindowScrollOpen( 0, 0, info->h, info->v,
				TitleWP, ScrH*Xdot, ScrV*Ydot,
				DirectionX|DirectionY, 32, Ydot, EventExec );
			CharBufClear();
			WindowSetEventAttr( TitleWP,
				EventAttrDefault|EventMouseMoveON|EventUserON);
			return	TRUE;
		case EventRedraw: {
			int	h= HS_WindowGetViewSizeX( wp ),
				v= HS_WindowGetViewSizeY( wp );
			IconMode= FALSE;
			DrawSetLine( buf, h-10, v-10, h, v,1/*Attr&AttrReverse?
						Attr&3:0*/, OptionFill );
			WindowDraw( wp, buf, 1 );
			WindowSendEvent( ComWP, info );
			return	TRUE;
			}
		case EventClose:
			MS_CURON();
			{
				ConsoleType	*ptr;
				if( ptr= WindowGetCommon( "Console", 0 ) ){
					if( ptr->wp == wp )
						WindowResetCommon( "Console" );
				}
			}
			WindowClose( TitleWP );
			WindowConnectionClose();
			return	TRUE;
		case EventResize: {
			int	h, v, x, y;
			zoom.zflag= FALSE;
			WindowResize( ComWP, 0, 0, info->h, info->v );
			h= HS_WindowGetViewSizeX( ComWP );
			v= HS_WindowGetViewSizeY( ComWP );
			x= HS_WindowGetHomeX( ComWP );
			y= HS_WindowGetHomeY( ComWP );
			if( y+v > ScrV*Ydot )
				y= ScrV*Ydot -v;
			WindowSetHome( ComWP, x, y );
			WindowResize( TitleWP, info->x, info->y, info->h, info->v );
			WindowResize( DummyWP, 0, 0, h, v );
			return	TRUE;
			}
		case EventZoom:
			ZoomOperation( wp, info );
			return	TRUE;
		case EventMouseEnter:
			LEDMOD( 4, insertmode );
			WindowDraw( ComWP, buf,
				InputSetCursorVisible( buf, &Input, TRUE ) );
			return	TRUE;
		case EventMouseOut:
			MS_CURON();
			WindowDraw( ComWP, buf,
				InputSetCursorVisible( buf, &Input, FALSE ) );
			return	TRUE;
		case EventMouseMove:
			MS_CURON();
			return	TRUE;
		case EventMouseSwitch:
			MS_CURON();
			if( info->LeftStat ){
				if( info->x > HS_WindowGetViewSizeX( wp )-10 &&
				   info->y>HS_WindowGetViewSizeY( wp )-10 ){
					WindowResizeOperation( wp, info );
					return	TRUE;
				}
			}
			return	WindowSendEvent( ComWP, info );
		case EventKey:
			GetKey( info->KeyCode, info->ShiftStat );
			return	TRUE;
		case EventIconify:
			IconMode= TRUE;
			IconEnt( wp, title_str, AttrDefault|4, 12 );
			return	TRUE;
		case EventUser:
			switch( info->ComData ){
				unsigned char	*cp, **p;
				case UserPaste:
				case UserString:
					for( cp= info->ComBuffer ; *cp ; cp++){
						if( *cp == '\r' )
							GetKey( '\r', 0 );
						else
							InputKey( buf, &Input, *cp, 0 );
					}
					WindowDraw( ComWP, buf,
						InputSetDraw( buf, &Input ) );
					return	TRUE;
				case UserStrings:
					for( p= info->ComBuffer ; *p ; p++ ){
						cp= *p;
						while( *cp )
							InputKey( buf, &Input, *cp++, 0 );
						InputKey( buf, &Input,' ', 0 );
					}
					WindowDraw( ComWP, buf,
						InputSetDraw( buf, &Input ) );
					return	TRUE;
				case 'COMA':
					ChildExec( info->ComBuffer );
					return	TRUE;
			}
	}
	return	FALSE;
}

int
EventExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	switch( info->option ){
		case EventOpen:
			{
			int	h,v;
			ComWP= wp;
			WindowSetEventAttr( ComWP, EventAttrDefault|EventMouseMoveON|EventUserON );
			WindowGetViewSize( ComWP, &h, &v );
			WindowSetHome( ComWP, 0, ScrV*Ydot - v );
			WindowOpen( 0, 0, h, v, ComWP, DummyExec );
			return	TRUE;
			}
		case EventRedraw:
			{
			DrawBuf	linebuf[LINES+2],
				*bufp= linebuf;
			short	y1, y2;
			short	i;
			DrawSetClear( bufp++, Attr&AttrReverse?Attr&3:0 );
			y1= info->y / Ydot;
			y2= (info->y + info->v) / Ydot +1;
			if( y1 < 0 )
				y1= 0;
			if( y2 >= ScrV )
				y2= ScrV -1;
			for( i= y1 ; i <= y2 ; i++ )
				DrawSetSymbol( bufp++, OFFSET, i*Ydot,
						CharBuf[i], Attr, Ydot );
			if( ExecFlag == FALSE )
				bufp+= InputSetDraw( bufp, &Input );
			WindowDraw( wp, linebuf, bufp - linebuf );
			return	TRUE;
			}
		case EventClose:
			return	TRUE;
		case EventMouseSwitch:
			if( info->LeftON ){
				SetClipBoard( wp, info );
				return	TRUE;
			}
	}
	return	FALSE;
}

static	int
DummyExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	switch( info->option ){
		case EventOpen:
			DummyWP= wp;
			break;
		case EventRedraw: {
			int	x, y;
			WindowGetViewPosition( DummyWP, &x, &y );
			info->x += x;
			info->y += y;
			WindowSendEvent( ComWP, info );
		}
	}
	return	TRUE;
}

#define	Ctrl(a)	((a)&0x1f)

static	void
GetKey( KeyCode, ShiftStat )
int		KeyCode ;
int		ShiftStat ;
{
	int	n;
	int	h, v;
	DrawBuf	linebuf[14], *bufp;

	static	unsigned char	*historyptr;
	static	int	historylen;
	static short	filec= FALSE;	/* t@C⊮ƒI	*/
	static struct FILBUF	f;
	short		cshhistory= FALSE;
	static short	ctrl_flag= FALSE;
	static short	escflag= FALSE;
	unsigned char	*pt,
			ptbuf[128];
	extern	_kk_EmacsMode;
	_kk_EmacsMode= FALSE;

	MS_CUROF();
	if( (ShiftStat & 2) || escflag ){
		escflag= FALSE;
		switch( KeyCode ){
			case FuncKeyLeft:
			case 'r':
				WindowScroll( ComWP, - 32, 0 );
				return;
			case FuncKeyRight:
			case 'l':
				WindowScroll( ComWP, 32, 0 );
				return;
			case FuncKeyUp:
			case 'k':
			case 'p':
			case 'e':
				WindowScroll( ComWP, 0, - Ydot );
				return;
			case FuncKeyDown:
			case 'j':
			case 'n':
			case 'x':
				WindowScroll( ComWP, 0, Ydot );
				return;
			case FuncKeyRollDown:
			case ',':
			case Ctrl('r'):
				WindowGetViewSize( ComWP, &h, &v );
				WindowScroll( ComWP, 0, - v );
				return;
			case FuncKeyRollUp:
			case '.':
			case Ctrl('c'):
				WindowGetViewSize( ComWP, &h, &v );
				WindowScroll( ComWP, 0, v );
				return;
		}
	}
	if( ctrl_flag ){
		ctrl_flag= FALSE;
		goto	default_;
	}
	switch( KeyCode ){	/* ̃[` goto ̗I */
		case Ctrl('['):
			escflag= TRUE;
			return;
		case Ctrl('l'):
			if( cshmode ) {
				cls();
#ifdef CTRL_L_PATCH /* 1995/12 daitei */
				WindowDraw( ComWP, linebuf,
					   InputSetCursorVisible( linebuf, &Input, FALSE ) );
#endif
			}
			goto	ret_end;
		case Ctrl('c'):
			filec= FALSE;
			historyptr = NULL ;
			historylen = 0 ;
			ExecFlag = TRUE ;
			Print( Comline );
			Print( "^C\n" );
			PrintLine( Prompt, FALSE );
			ExecFlag = FALSE ;
			break ;
		case '\r':	/* RETURN */
			if( cshmode && *Comline == '!' ){
				if( Comline[1] == '!' ){
					*Comline= '\0';
					pt= Comline+2;
				}else{
					for( pt= Comline+1 ; *pt && !isspace(*pt) ; pt[-1]= *pt, pt++ );
				}
				if( *pt ){
					cshhistory= TRUE;
					strcpy( ptbuf, pt );
				}
				pt[-1]= '\0';
				KeyCode= FuncKeyUnDo;
				historyptr= NULL;
				historylen= strlen( Comline );
				goto	orig_ctrle;
			}
		returnkey:
			if( cshhistory )
				strcat( Comline, ptbuf );
			filec= FALSE;
			HistoryAppend( Comline );
			historyptr = NULL ;
			historylen = 0 ;
			n = InputGetCursor( &Input );
			DrawSetLine( linebuf, OFFSET+(Cx+n)*Xdot, Cy*Ydot,
				1024, (Cy+1)*Ydot, Attr&AttrReverse? Attr&3:0,
					OptionFill );
			WindowDraw( ComWP, linebuf, 1 );
			ExecFlag = TRUE ;
			PrintLine( Comline, TRUE );
			SetCurDir( Prompt );
			if( ChildExec( Comline ) ){
				WindowClose( TitleWP );
				WindowConnectionClose() ;
				MS_CURON();
				return;
			}
/*			GetPrompt( Prompt );*/
		ret_end:
			SetCurDir( Prompt );
			PrintLine( Prompt, FALSE );
			ExecFlag= FALSE;
			break ;
		case Ctrl('d'):
			if( cor_flag == EMACSMODE )
				KeyCode= Ctrl('g');
			goto	default_;
		case Ctrl('f'):
			if( cor_flag != EMACSMODE )
				goto	default_;
			KeyCode= Ctrl('d');
			goto	default_;
		case Ctrl('b'):
			if( cor_flag == EMACSMODE )
				KeyCode= Ctrl('s');
			goto	default_;
		case Ctrl('e'):
			if( cor_flag == EDXMODE )
				goto	orig_ctrle;
			if( cor_flag == HISTORYMODE )
				goto	ed_ctrle;
			KeyCode= Ctrl('p');
			goto	default_;
		case Ctrl('a'):
			if( cor_flag != EMACSMODE )
				goto	default_;
			KeyCode= Ctrl('q');
			goto	default_;
		case FuncKeyUp:
			if( cor_flag == HISTORYMODE ){
				KeyCode= Ctrl('a');
				goto	default_;
			}
		case FuncKeyRollDown:
		case Ctrl('p'):
		case Ctrl('w'):
		case FuncKeyUnDo:
		orig_ctrle:
			historyptr = HistoryLast( historyptr, Comline, historylen );
			goto HistoryGet ;
		case FuncKeyDown:
			if( cor_flag == HISTORYMODE ){
				KeyCode= Ctrl('f');
				goto	default_;
			}
		case FuncKeyRollUp:
		case Ctrl('n'):
		ed_ctrle:
		case Ctrl('x'):
			historyptr= HistoryNext( historyptr, Comline, historylen );
		HistoryGet:
			filec= FALSE;
			if( historyptr != NULL ){
				strcpy( Comline, historyptr );
			fileok:
				InputSetCursor( &Input, strlen( Comline ) );
				bufp = linebuf ;
				DrawSetLine( bufp++, OFFSET+Cx*Xdot, Cy*Ydot,
					1024, (Cy+1)*Ydot, Attr&AttrReverse?
						Attr&3:0, OptionFill );
				bufp += InputSetDraw( bufp, &Input );
				WindowDraw( ComWP, linebuf, bufp - linebuf );
			}
			if( KeyCode == FuncKeyUnDo )
				goto	returnkey;
			return;
		case Ctrl('i'):
			SetCurDir( Prompt );
			{/* t@C⊮I	*/
				static unsigned char	path[80],
							buf[80],
							com[256];
				if( !*Comline )
					return;
				if( !filec ){
					unsigned char	*p= com,
							*last= com;
					strcpy( com, Comline );
					for(; *p ; p++ ){
						if( isspace( *p ) ){
							while( isspace( *p ) )
								p++;
							if( *p )
								last= p;
							else
								break;
						}
					}
					strcpy( buf, last );
					strcpy( path, last );
					*last= '\0';
					for( last= p= path ; *p ; p++ ){
						if( *p == ':' || *p == '/' || *p == '\\' )
							last= p+1;
					}
					if( !strchr( last, '*' ) )
						strcat( buf, strchr(last,'.') ? "*" : "*.*" );
					*last= '\0';
				retry:
					if( FILES( &f, buf, 0x3f )>=0 ){
					fileok1:
						strcpy( Comline, com );
						strcat( Comline, path );
						strcat( Comline, f.name );
						filec= TRUE;
						goto	fileok;
					}
				}else{
					if( NFILES( &f ) >= 0 ){
						goto	fileok1;
					}else{
						filec= FALSE;
						goto	retry;
					}
				}
			}
			return;
		case Ctrl('q'):
			if( cor_flag != EMACSMODE )
				goto	default_;
			KeyCode= Ctrl('v');
		case Ctrl('v'):
			ctrl_flag= TRUE;
		default:
		default_:
			/* t@NVL[I */
			if( KeyCode >= 0x8001 && KeyCode <= 0x8014 ){
				EventInfo	info;
				unsigned char	*p= keystr[KeyCode-0x8001];
				int		i= strlen(p)-1;
				info.option= EventUser;
				info.ComData= UserString;
				info.ComBuffer= p;
				if( *p && p[i] == '\r' )
					p[i]= '\0';
				WindowSendEvent( TitleWP, &info );
				if( *p && !p[i] ){
					p[i]= '\r';
					goto	returnkey;
				}
			}else{
				filec= FALSE;
				bufp= linebuf ;
				bufp+= InputKey( bufp, &Input, KeyCode, ShiftStat );
				WindowDraw( ComWP, linebuf, bufp-linebuf );
				historyptr= NULL;
				historylen= strlen( Comline );
			}
			return;
	}
	InputSet( &Input, OFFSET+Xdot*strlen( Prompt ), Cy*Ydot, Comline, ScrH,
				Attr, Ydot );
	*Comline= '\0';
Key_Redraw:
	WindowDraw( ComWP, linebuf, InputSetDraw( linebuf, &Input ) );
}

void
CharBufClear()
{
	int	i;
	int	v= HS_WindowGetViewSizeY( ComWP )/Ydot;

	memcpy( CharBuf[0], CharBuf[v+1], (ScrV-v-1)*COLUMS );
	for( i= 0 ; i < v+1 ; i++ )
		*CharBuf[ ScrV-i-1 ]= '\0';

	VirCx=
	Cx= 0;
	Cy= ScrV -v;
	PrintChar( 0 );
	InputSet( &Input, OFFSET+Xdot*strlen( Prompt ), Cy*Ydot,
						Comline, ScrH, Attr, Ydot );
	*Comline= '\0';
}
